routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::prefix('spp')->group(function(){
    Auth::routes();

    Route::middleware(['auth:web'])->group(function(){
        Route::get('/', 'HomeController@index')->name('web.index');
        Route::get('buku-panduan', function(){
            return view('panduan.buku');
        })->name('buku.panduan');

        Route::get('pengaturan','HomeController@pengaturan')->name('pengaturan.index');
        Route::get('ubah-pengaturan','HomeController@editPengaturan')->name('pengaturan.edit');
        Route::post('ubah-pengaturan','HomeController@storePengaturan')->name('pengaturan.store');
        Route::Post('cetak-laporan-harian','HomeController@cetak')->name('laporan-harian.cetak');
        Route::post('export-laporan-harian','HomeController@export')->name('laporan-harian.export');
    
        //Siswa
        Route::get('siswa','SiswaController@index')->name('siswa.index');
        Route::get('tambah-siswa','SiswaController@create')->name('siswa.create');
        Route::post('tambah-siswa', 'SiswaController@store')->name('siswa.store');
        Route::get('siswa/{siswa}/detail', 'SiswaController@show')->name('siswa.show');
        Route::get('siswa/{siswa}/ubah', 'SiswaController@edit')->name('siswa.edit');
        Route::post('siswa/{siswa}/ubah','SiswaController@update')->name('siswa.update');
        Route::post('siswa/{siswa}/hapus', 'SiswaController@destroy')->name('siswa.destroy');
        Route::get('import-siswa', 'SiswaController@showFormImport')->name('siswa.showimport');
        Route::post('import-siswa', 'SiswaController@import')->name('siswa.import');
        Route::get('export-siswa', 'SiswaController@export')->name('siswa.export');
    
        //Periode
        Route::get('periode','PeriodeController@index')->name('periode.index');
        Route::get('tambah-periode','PeriodeController@create')->name('periode.create');
        Route::post('tambah-periode', 'PeriodeController@store')->name('periode.store');
        Route::get('periode/{periode}/ubah', 'PeriodeController@edit')->name('periode.edit');
        Route::post('periode/{periode}/ubah','PeriodeController@update')->name('periode.update');
        Route::post('periode/{periode}/hapus', 'PeriodeController@destroy')->name('periode.destroy'); 
    
        //Kelas
        Route::get('kelas','KelasController@index')->name('kelas.index');
        Route::get('tambah-kelas','KelasController@create')->name('kelas.create');
        Route::post('tambah-kelas', 'KelasController@store')->name('kelas.store');
        Route::get('kelas/{kelas}/ubah', 'KelasController@edit')->name('kelas.edit');
        Route::post('kelas/{kelas}/ubah','KelasController@update')->name('kelas.update');
        Route::post('kelas/{kelas}/hapus', 'KelasController@destroy')->name('kelas.destroy');
    
        //Tagihan
        Route::get('tagihan','TagihanController@index')->name('tagihan.index');
        Route::get('tambah-tagihan','TagihanController@create')->name('tagihan.create');
        Route::post('tambah-tagihan', 'TagihanController@store')->name('tagihan.store');
        Route::get('tagihan/{tagihan}/ubah', 'TagihanController@edit')->name('tagihan.edit');
        Route::post('tagihan/{tagihan}/ubah','TagihanController@update')->name('tagihan.update');
        Route::post('tagihan/{tagihan}/hapus', 'TagihanController@destroy')->name('tagihan.destroy');
    
        //Users
        Route::get('user','UserController@index')->name('user.index');
        Route::get('tambah-user','UserController@create')->name('user.create');
        Route::post('tambah-user', 'UserController@store')->name('user.store');
        Route::get('user/{user}/ubah', 'UserController@edit')->name('user.edit');
        Route::post('user/{user}/ubah','UserController@update')->name('user.update');
        Route::post('user/{user}/hapus', 'UserController@destroy')->name('user.destroy');
    
        //Menabung
        Route::get('tabungan', 'TabunganController@index')->name('tabungan.index');
        Route::post('menabung', 'TabunganController@menabung')->name('tabungan.store');
        Route::get('cetak-tabungan/{id}', 'TabunganController@transaksiCetak')->name('tabungan.transaksicetak');
        Route::get('export-mutasi', 'TabunganController@export')->name('tabungan.export');
        Route::get('cetak-tabungan-siswa/{siswa}', 'TabunganController@cetak')->name('tabungan.cetak');
        Route::get('export-tabungan/{siswa}', 'TabunganController@siswaexport')->name('tabungan.siswa.export');
    
        //Keuangan 
        Route::get('keuangan', 'KeuanganController@index')->name('keuangan.index');
        Route::post('keuangan', 'KeuanganController@store')->name('keuangan.store');
        Route::get('export-keuangan', 'KeuanganController@export')->name('keuangan.export');
    
        //Pembayaran SPP
        Route::get('transaksi-spp','TransaksiController@index')->name('spp.index');
        Route::post('print-spp', 'TransaksiController@transaksiPrint')->name('transaksi.print');
        Route::get('export-spp','TransaksiController@transaksiExport')->name('transaksi.export');
        Route::post('print-spp/{siswa?}','TransaksiController@print')->name('spp.print');
        Route::post('export-spp/{siswa?}','TransaksiController@export')->name('spp.export');
    
        //Kuitansi 
        Route::get('kuitansi', 'KuitansiController@index')->name('kuitansi.index');
        Route::post('kuitansi', 'KuitansiController@store')->name('kuitansi.store');
        Route::get('kuitansi/{kuitansi}', 'KuitansiController@print')->name('kuitansi.print');
    });
// });

app/Models/Tagihan.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Tagihan extends Model
{
    use SoftDeletes;

    protected $table = 'tagihan';

    protected $fillable = [
        'nama',
        'jumlah',
        'wajib_semua',
        'kelas_id'
    ];

    public function transaksi(){
        return $this->hasMany('App\Models\Transaksi','tagihan_id','id');
    }

    public function transaksiToday(){
        return $this->transaksi()->whereDate('created_at', now()->today());
    }

    public function role(){
        return $this->hasMany('App\Models\Role','tagihan_id','id');
    }

    public function siswa(){
        return $this->belongsToMany('App\Models\Siswa','role');
    }

    public function kelas(){
        return $this->hasOne('App\Models\Kelas','id','kelas_id');
    }

    public function getJumlahIdrAttribute(){
        return "IDR. ".format_idr($this->jumlah);
    }
}

app/Http/Controllers/TagihanController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Tagihan;
use App\Models\Kelas;
use App\Models\Siswa;
use App\Models\Role;
use Illuminate\Support\Facades\Redirect;

class TagihanController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $tagihan = Tagihan::orderBy('created_at','desc')->paginate(10);
        return view('tagihan.index', ['tagihan' => $tagihan]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $kelas = Kelas::all();
        $siswa = Siswa::where('is_yatim','!=','1')->get();
        return view('tagihan.form',[
            'kelas' => $kelas,
            'siswa' => $siswa
        ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'nama' => 'required|max:255',
            'jumlah' => 'required|numeric',
            'peserta' => 'required|numeric'
        ]);

        $tagihan = Tagihan::make($request->except('kelas_id'));

        switch($request->peserta){
            case 1: // semua
                $tagihan->wajib_semua = 1;
                break;
            case 2: // hanya kelas
                $tagihan->kelas_id = $request->kelas_id;
                break;
            case 3: // siswa , make role
                $tagihan->save();
                foreach($request->siswa_id as $siswa_id){
                    $tagihan->siswa()->save(Siswa::find($siswa_id));
                }
                break;
            default:
                return Redirect::back()->withErrors(['Peserta Wajib diisi']);
        }

        if($tagihan->save()){
            return redirect()->route('tagihan.index')->with([
                'type' => 'success',
                'msg' => 'Item Tagihan ditambahkan'
            ]);
        }else{
            return redirect()->route('tagihan.index')->with([
                'type' => 'danger',
                'msg' => 'Err.., Terjadi Kesalahan'
            ]);
        }
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(Tagihan $tagihan)
    {
        $kelas = Kelas::all();
        $siswa = Siswa::where('is_yatim','!=','1')->get();
        return view('tagihan.form',[
            'kelas' => $kelas,
            'siswa' => $siswa,
            'tagihan' => $tagihan
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Tagihan $tagihan)
    {
        $request->validate([
            'nama' => 'required|max:255',
            'jumlah' => 'required|numeric',
            'peserta' => 'required|numeric'
        ]);

        $tagihan->fill($request->except('kelas_id'));
        
        //remove all related
        $tagihan->siswa()->detach();
        $tagihan->kelas_id = null;
        $tagihan->wajib_semua = null;

        switch($request->peserta){
            case 1: // semua
                $tagihan->wajib_semua = 1;
                break;
            case 2: // hanya kelas
                $tagihan->kelas_id = $request->kelas_id;
                break;
            case 3: // siswa , make role
                foreach($request->siswa_id as $siswa_id){
                    $tagihan->siswa()->save(Siswa::find($siswa_id));
                }
                break;
            default:
                return Redirect::back()->withErrors(['Peserta Wajib diisi']);
        }

        if($tagihan->save()){
            return redirect()->route('tagihan.index')->with([
                'type' => 'success',
                'msg' => 'Item Tagihan diubah'
            ]);
        }else{
            return redirect()->route('tagihan.index')->with([
                'type' => 'danger',
                'msg' => 'Err.., Terjadi Kesalahan'
            ]);
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Tagihan $tagihan)
    {
        if($tagihan->transaksi->count() != 0){
            return redirect()->route('tagihan.index')->with([
                'type' => 'danger',
                'msg' => 'tidak dapat menghapus tagihan yang masih memiliki transaksi'
            ]);
        }
        $tagihan->siswa()->detach();
        if($tagihan->delete()){
            return redirect()->route('tagihan.index')->with([
                'type' => 'success',
                'msg' => 'tagihan telah dihapus'
            ]);
        }
    }
}

resources/views/tagihan/form.blade.php
@extends('layouts.app')

@section('site-name','Sistem Informasi SPP')
@section('page-name', (isset($tagihan) ? 'Ubah Tagihan' : 'Tagihan Baru'))

@section('content')
    <div class="row">
        <div class="col-8">
            <form action="{{ (isset($tagihan) ? route('tagihan.update', $tagihan->id) : route('tagihan.create')) }}" method="post" class="card">
                <div class="card-header">
                    <h3 class="card-title">@yield('page-name')</h3>
                </div>
                <div class="card-body">
                    @if($errors->any())
                        <div class="alert alert-danger">
                            @foreach($errors->all() as $error)
                                {{ $error }}<br>
                            @endforeach
                        </div>
                    @endif
                    <div class="row">
                        <div class="col-12">
                            @csrf
                            <div class="form-group">
                                <label class="form-label">Nama</label>
                                <input type="text" class="form-control" name="nama" placeholder="Nama" value="{{ isset($tagihan) ? $tagihan->nama : old('nama') }}" required>
                            </div>
                            <div class="form-group">
                                <label class="form-label">Jumlah</label>
                                <input type="number" class="form-control" name="jumlah" value="{{ isset($tagihan) ? $tagihan->jumlah : old('jumlah') }}" required>
                            </div>
                            <div class="form-group">
                                <div class="form-label">Peserta</div>
                                <div class="custom-switches-stacked">
                                <label class="custom-switch">
                                <input type="radio" name="peserta" value="1" class="custom-switch-input" {{ isset($tagihan) ? ($tagihan->wajib_semua == 1 ? 'checked' : '') : 'checked' }}>
                                <span class="custom-switch-indicator"></span>
                                <span class="custom-switch-description">Wajib Semua Siswa</span>
                                </label>
                                <label class="custom-switch">
                                <input type="radio" name="peserta" value="2" class="custom-switch-input" {{ isset($tagihan) ? (($tagihan->kelas_id != null) ? 'checked' : '') : '' }}>
                                <span class="custom-switch-indicator"></span>
                                <span class="custom-switch-description">Hanya Kelas</span>
                                </label>
                                <label class="custom-switch">
                                <input type="radio" name="peserta" value="3" class="custom-switch-input" {{ isset($tagihan) ? (($tagihan->kelas_id == null && $tagihan->wajib_semua == null) ? 'checked' : '') : '' }}>
                                <span class="custom-switch-indicator"></span>
                                <span class="custom-switch-description">Hanya Siswa</span>
                                </label>
                            </div>
                            </div>
                            <div class="form-group" style="display: {{ isset($tagihan) ? (($tagihan->kelas_id != null) ? 'block' : 'none') : 'none' }}" id="form-kelas">
                                <label class="form-label">Kelas</label>
                                <select class="form-control" name="kelas_id" id="hanya-kelas">
                                    @foreach($kelas as $item)
                                        <option value="{{ $item->id }}" {{ isset($tagihan) ? (($tagihan->kelas_id == $item->id) ? 'selected' : '') : '' }}>
                                            {{ $item->nama }} - {{ isset($item->periode) ? $item->periode->nama : '' }}
                                        </option>
                                    @endforeach
                                </select>
                            </div>
                            <div class="form-group" style="display: {{ isset($tagihan) ? (($tagihan->kelas_id == null && $tagihan->wajib_semua == null) ? 'block' : 'none') : 'none' }}" id="form-siswa">
                                <label class="form-label">Siswa</label>
                                <select class="form-control" name="siswa_id[]" id="hanya-siswa" multiple>
                                    @foreach($siswa as $item)
                                        <option value="{{ $item->id }}" {{ isset($tagihan) ? (($tagihan->wajib_semua == null && $tagihan->kelas_id == null) ? (in_array($item->id, $tagihan->siswa->pluck('id')->toArray()) ? 'selected' : '') : '') : '' }}>
                                            {{ $item->nama }} - {{ $item->kelas->nama }} {{ isset($item->kelas->periode) ? "(". $item->kelas->periode->nama .")" : ''}}
                                        </option>
                                    @endforeach
                                </select>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="card-footer text-right">
                    <div class="d-flex">
                        <a href="{{ url()->previous() }}" class="btn btn-link">Batal</a>
                        <button type="submit" class="btn btn-primary ml-auto">Simpan</button>
                    </div>
                </div>
            </form>
        </div>
    </div>
@endsection
@section('css')
    <link href="{{ asset('assets/plugins/select2/select2.min.css') }}" rel="stylesheet" />
    <style>
        .select2-container--default .select2-selection--multiple .select2-selection__choice {
            color: black;
        }
        .select2{
            width: 100% !important;
        }
    </style>
@endsection
@section('js')
<script>
    require(['jquery', 'selectize','select2'], function ($, selectize) {
        $(document).ready(function () {
            $('#select-beast').selectize({});
        });
        $('#hanya-kelas').select2({
            placeholder: "Pilih Kelas",
        });
        $('#hanya-siswa').select2({
            placeholder: "Pilih Siswa",
        });

        $('.custom-switch-input').change(function(){
            if(this.value == 2){
                $('#form-kelas').show()
                $('#form-siswa').hide()

                $('#hanya-kelas').prop('required', true)
                $('#hanya-siswa').prop('required', false)
            }else if(this.value == 3){
                $('#form-kelas').hide()
                $('#form-siswa').show()

                $('#hanya-kelas').prop('required', false)
                $('#hanya-siswa').prop('required', true)
            }else{
                $('#form-kelas').hide()
                $('#form-siswa').hide()

                $('#hanya-kelas').prop('required', false)
                $('#hanya-siswa').prop('required', false)
            }
        })
    });
</script>
@endsection

resources/views/tagihan/index.blade.php
@extends('layouts.app')

@section('site-name','Sistem Informasi SPP')
@section('page-name','Tagihan')

@section('content')
    <div class="page-header">
        <h1 class="page-title">
            @yield('page-name')
        </h1>
    </div>
    <div class="row">
        <div class="col-12">
            <div class="card">
                <div class="card-header">
                    <h3 class="card-title">@yield('page-name')</h3>
                    <a href="{{ route('tagihan.create') }}" class="btn btn-outline-primary btn-sm ml-5">Tambah Tagihan</a>
                </div>
                @if(session()->has('msg'))
                <div class="card-alert alert alert-{{ session()->get('type') }}" id="message" style="border-radius: 0px !important">
                    @if(session()->get('type') == 'success')
                        <i class="fe fe-check mr-2" aria-hidden="true"></i>
                    @else
                        <i class="fe fe-alert-triangle mr-2" aria-hidden="true"></i> 
                    @endif
                        {{ session()->get('msg') }}
                </div>
                @endif
                <div class="table-responsive">
                    
                    <table class="table card-table table-hover table-vcenter text-wrap">
                        <thead>
                        <tr>
                            <th class="w-1">No.</th>
                            <th>Nama</th>
                            <th>Jumlah</th>
                            <th>Peserta</th>
                            <th></th>
                        </tr>
                        </thead>
                        <tbody>
                        @foreach ($tagihan as $index => $item)
                            <tr>
                                <td><span class="text-muted">{{ $index+1 }}</span></td>
                                <td>
                                    {{ $item->nama }}
                                </td>
                                <td>
                                    {{ $item->jumlah_idr }}
                                </td>
                                <td style="max-width: 150px">
                                    @if($item->wajib_semua != null)
                                        <p>Wajib Semua</p>
                                    @elseif($item->kelas_id != null)
                                        <p>{{ $item->kelas->nama }} {{ isset($item->kelas->periode) ? ' - '.$item->kelas->periode->nama : '' }}</p>
                                    @elseif($item->wajib_semua == null && $item->kelas_id == null)
                                        @foreach ($item->role as $role)
                                            {{ $role->siswa->nama }}{{ " (".$role->siswa->kelas->nama.")" }},
                                        @endforeach
                                    @endif
                                </td>
                                <td class="text-center">
                                    <a class="icon" href="{{ route('tagihan.edit', $item->id) }}" title="edit item">
                                        <i class="fe fe-edit"></i>
                                    </a>
                                    <a class="icon btn-delete" href="#!" data-id="{{ $item->id }}" title="delete item">
                                        <i class="fe fe-trash"></i>
                                    </a>
                                    <form action="{{ route('tagihan.destroy', $item->id) }}" method="POST" id="form-{{ $item->id }}">
                                        @csrf 
                                    </form>
                                </td>
                            </tr>
                        @endforeach
                        </tbody>
                    </table>
                </div>
                <div class="card-footer">
                    <div class="d-flex">
                        <div class="ml-auto mb-0">
                            {{ $tagihan->links() }}
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection
@section('js')
<script>
    require(['jquery', 'sweetalert'], function ($, sweetalert) {
        $(document).ready(function () {

            $(document).on('click','.btn-delete', function(){
                formid = $(this).attr('data-id');
                swal({
                    title: 'Anda yakin ingin menghapus?',
                    text: 'tagihan yang dihapus tidak dapat dikembalikan',
                    dangerMode: true,
                    buttons: {
                        cancel: true,
                        confirm: true,
                    },
                }).then((result) => {
                    if (result) {
                        $('#form-' + formid).submit();
                    }
                })
            })

        });
    });
</script>
@endsection